{$N-}

Uses
  Dos, Crt, Graph, Screen ;

var
  f : file of DOTS ;
  fn , fn2 : string ;
  SP : DOTSpointer ;
  count , x , y : integer ;
  ch : char ;
  PrtError : byte ;
  NumericUsed : boolean ;
  SR : SearchRec ;

function PrinterReady : boolean ;
begin
  inline($B4/$02/                      {    MOV    AH,02             }
         $BA/$00/$00/                  {    MOV    DX,0000           }
         $CD/$17/                      {    INT    17H               }
         $80/$E4/$08/                  {    AND    AH,08             }
         $D0/$EC/                      {    SHR    AH,1              }
         $D0/$EC/                      {    SHR    AH,1              }
         $D0/$EC/                      {    SHR    AH,1              }
         $88/$26/PrtError) ;           {    MOV    PrtError,AH       }
  if PrtError=1 then PrinterReady:=false
                else PrinterReady:=true ;
end ;

procedure beep ;
begin
  sound(1500) ; delay(50) ; nosound ; delay(50) ;
  sound(1500) ; delay(50) ; nosound ;
end ;

begin
  DirectVideo:=false ;
  NumericUsed:=false ;
  fn:=ParamStr(1) ;
  if fn='' then begin
    writeln ('Usage :     RNO PICTURE.PIC') ;
    writeln ;
    writeln ('When a picture is on the screen ...') ;
    writeln ('Use NUMERIC PAD to move a picture.') ;
    writeln ;
    writeln ('  7 8 9  -  Up-left, Up, Up-right') ;
    writeln ('  4   6  -  left, right') ;
    writeln ('  1 2 3  -  Down-left, Down, Down-right') ;
    writeln ('  Ins    -  Center') ;
    writeln ('  Del    -  2 bit (4 grades) representation, full screen (default)') ;
    writeln ;
    writeln ('  F1     -  Hard Copy mode 1  ( ratio 0.98 )') ;
    writeln ('  F2     -  Hard Copy mode 2  ( ratio 0.94 )') ;
    writeln ('  F3     -  Hard Copy mode 3  ( half size )') ;
    writeln ;
    writeln ('  All are 3 bit (8 grades) representations, except full screen mode.') ;
    writeln ('  If F1,F2, or F3 is pressed when a printer is not ready, power off,') ;
    writeln ('    or of no paper, then two 1500 Hz pulses will alert you.') ;
    writeln ;
    halt ;
  end ;
  New(SP) ;
  repeat
    assign (f,fn) ; reset(f) ;
    read(f,SP^) ;
    close(f) ;
    x:=HercMono ; y:=0 ;
    InitGraph(x,y,'') ;
    ScreenCopy($B000,SP,0,0) ;
    count:=0 ;
    repeat
      repeat until keypressed ;
      ch:=ReadKey ;
      if ch=#0 then ch:=ReadKey ;
      case ord(ch) of
        71,55 : ScreenCopy2($B000,SP,0,0) ;
        73,57 : ScreenCopy2($B000,SP,60,0) ;
        79,49 : ScreenCopy2($B000,SP,0,58) ;
        81,51 : ScreenCopy2($B000,SP,60,58) ;
        82,48,53 : ScreenCopy2($B000,SP,30,29) ;
        72,56 : ScreenCopy2($B000,SP,30,0) ;
        75,52 : ScreenCopy2($B000,SP,0,29) ;
        77,54 : ScreenCopy2($B000,SP,60,29) ;
        80,50 : ScreenCopy2($B000,SP,30,58) ;
        59    : if PrinterReady then HardCopy(SP,0,0,1)
                                else beep ;
        60    : if PrinterReady then HardCopy(SP,0,0,2)
                                else beep ;
        61    : if PrinterReady then HardCopy(SP,0,0,3)
                                else beep ;
        83,46 : begin
                  ClearViewPort ;
                  ScreenCopy($B000,SP,0,0) ;
                end ;
        else ch:=#255 ;
      end ;
      inc(count) ;
    until ch=#255 ;
    if count>1 then NumericUsed:=true ;
    CloseGraph ;
    write ('Another file / Directory / Quit ') ;
    ch:=Upcase(ReadKey) ;
    writeln ;
    if ch='A' then begin
      write ('File name : ') ; readln (fn) ;
    end
    else if ch='D' then begin
      fn:='' ;
      write ('Picture file drive or path : ') ; readln (fn) ;
      if not ((fn='') or (fn[ord(fn[0])]=':') or (fn[ord(fn[0])]='\')) then
        fn:=fn+'\' ;
      fn2:=fn ;
      FindFirst(fn+'*.PIC',$3F,SR) ;
      writeln ;
      repeat
        fn:=SR.Name ;
        write (SR.Name:16) ;
        FindNext(SR) ;
      until SR.Name=fn ;
      writeln ;
      write ('Select one : ') ; readln (fn) ;
      fn:=fn2+fn ;
    end ;
  until not ((ch='A') or (ch='D')) ;
  if not NumericUsed then
    writeln ('Remember !   You can get help, if you just type RNO at DOS prompt.') ;
end.